
import numpy as np

def excess(freq, ifo):
    '''
    Excess noise with LIGO O1 (2.5e-20/f^2)
    '''
    try:
        ex = ifo.Technical.get('Excess', 0)
    except:
        ex = 0

    return (ex*2.5e-20/freq**2)**2 if ex > 0 else np.zeros(len(freq))
