
from pyrange import frange

dir  = 'psd/'

psds = [ 'H1_O2.txt', 'L1_O2.txt', 'V1_O2.txt',
         'H1_O3.txt', 'L1_O3.txt', 'V1_O3.txt',    #5
         'aligo_O4low.txt',   'aligo_O4high.txt', 
         'AplusDesign.txt',                        #8
         'avirgo_O4low.txt',  'avirgo_O4high.txt',
         'avirgo_O5low.txt',  'avirgo_O5high.txt', #12
         'kagra_130Mpc.txt',  'kagra_80Mpc.txt',   'kagra_25Mpc.txt',
         'kagra_15Mpc.txt',   'kagra_8Mpc.txt' ]   #16

rbns = [ 77.11, 96.03, 27.08,  105.68, 130.35, 50.05,
         164.99, 185.08, 331.86,  90.84, 118.83, 148.86, 264.30,
         131.94, 79.09, 24.39, 14.48, 7.75 ]
rbbh = [ 751.98, 909.22, 275.04,  995.27, 1184.95, 498.06,
         1443.43, 1574.38, 2476.18,  857.77, 1081.77, 1315.38, 2118.72,
         1211.43, 777.96, 260.26, 154.05, 81.27 ]
rimb = [ 1343.58, 1764.68, 564.81,  1578.91, 1957.44, 990.13,
         2243.69, 2513.36, 3270.26,  1515.29, 1890.82, 2082.21, 3185.76,
         1868.78, 1050.35, 386.30, 266.98, 170.61 ]

def rcmp(psd, refs= None):
    bns = frange(psd)
    bbh = frange(psd, m=30)
    imb = frange(psd, m=100)
    fmt = ' {:8.1f}'

    if refs is not None:
        bns /= refs[0]
        bbh /= refs[1]
        imb /= refs[2]
        fmt  = ' {:8.3f}'

    print ('{:21}'+fmt+fmt+fmt).format(psd, bns, bbh, imb)

def pcmp():
    print '{:21} {:8} {:8} {:8}'\
        .format('PSD file',' BNS/Mpc',' BBH/Mpc', 'IMBH/Mpc')
    for r1,r2,r3,f in zip(rbns, rbbh, rimb, psds):
        rcmp(dir+f, [r1,r2,r3])
       
def prng():
    print '{:21} {:8} {:8} {:8}'\
        .format('PSD file',' BNS/Mpc',' BBH/Mpc', 'IMBH/Mpc')

    print 'O2'
    for p in psds[0:3]:
        rcmp(dir+p)

    print 'O3'
    for p in psds[3:6]:
        rcmp(dir+p)

    print 'O4'
    for i in [6, 7, 9, 10, 15, 14, 13]:
        rcmp(dir+psds[i])

    print 'O5'
    for i in [8, 11, 12]:
        rcmp(dir+psds[i])

def getps(ii):
    ps = []
    for i in ii:
        ps.append(dir+psds[i])
    return ps

def nrange(s, ii, dc=1, smin=4):
    ps = getps(ii)
    sr = frange(ps, dc=dc, smin=smin)
    ar = frange(ps, opt='CA')
    fr = (ar/sr)**3*100
    print '%-12s BNS: %6.1f %6.1f Mpc (%4.1f %%)' % (s, sr, ar, fr)

def nrng():
    ps1 = getps([6, 6, 9, 14]) # HLVK
    ps2 = getps([6, 6, 9])     # HLV

    ps3 = getps([6, 6, 15])    # HLK
    ps4 = getps([6, 9, 15])    # HVK/LVK
    ps5 = getps([6, 6])        # HL
    ps6 = getps([6, 9])        # HV/LV
    ps7 = getps([6, 15])       # HK/LK
    ps8 = getps([9, 15])       # VK

    '''
    sr0 = frange(ps2)
    sr1 = frange(ps2, dc=0.7)
    print 'sr=',sr0,sr1
    # sr= 161.46948916262414 133.40387220679958

    sr0 = frange(ps2, opt='CA')
    sr1 = frange(ps2, opt='CA', dc=0.7)
    sr2 = frange(ps1, opt='CA', dc=0.7)
    print 'sr=',sr0,sr1,sr2
    return
    '''

    for dc in [0.7, 0.8, 0.9, 1]:
        sr1 = frange(ps1, dc=dc)
        sr2 = frange(ps2, dc=dc)
        sr3 = frange(ps1, dc=dc, opt='CA')
        sr4 = frange(ps2, dc=dc, opt='CA')
        fr1 = ((sr1/sr2)**3-1)*100
        fr2 = ((sr3/sr4)**3-1)*100
        print 'BNS (dc=%.1f): %6.1f %6.1f (%4.1f %%) %6.1f %6.1f (%4.1f %%)'\
            % (dc, sr1, sr2, fr1, sr3, sr4, fr2)

    '''
    K:14(80 Mpc)
    BNS (dc=0.7):  141.3  133.4 (18.9 %)
    BNS (dc=0.8):  151.4  143.7 (17.1 %)
    BNS (dc=0.9):  160.6  153.0 (15.7 %)
    BNS (dc=1.0):  169.2  161.5 (15.0 %)
    '''

    return

    sr1 = frange(ps1)
    sr2 = frange(ps2)
    sr3 = frange(ps3)
    sr4 = frange(ps4)

    sr5 = frange(ps5)
    sr6 = frange(ps6)
    sr7 = frange(ps7)
    sr8 = frange(ps8)

    srd = frange(ps1, dc=0.7)

    print 'BNS: %6.1f %6.1f %6.1f %6.1f %6.1f Mpc' % (sr1, sr2, sr3, sr4, srd)
    print 'BNS: %6.1f %6.1f %6.1f %6.1f %6.1f Mpc' % (sr5, sr6, sr7, sr8, srd)
    return

    nrange('O4low (smin= 0)', [6, 6, 9], smin=0)
    nrange('O4low (smin= 4)', [6, 6, 9], smin=4)
    nrange('O4low (smin= 8)', [6, 6, 9], smin=8)

    nrange('O2',          [0, 1, 2])
    nrange('O3',          [3, 4, 5])
    nrange('O3+K15',      [3, 4, 5, 16])
    nrange('O3+K25',      [3, 4, 5, 15])
    nrange('O4low',       [6, 6, 9])
    nrange('O4low+K25',   [6, 6, 9, 15])
    nrange('O4high',      [7, 7, 10])
    nrange('O4high+K80',  [7, 7, 10, 14])
    nrange('O4high+K130', [7, 7, 10, 13])
    nrange('O5low',       [8, 8, 11])
    nrange('O5low+K80',   [8, 8, 11, 14])
    nrange('O5high',      [8, 8, 12])
    nrange('O5high+K130', [8, 8, 12, 13])

from optparse import OptionParser
parser = OptionParser()
parser.add_option('-c', '--pcmp', action = 'store_true', default = False)
parser.add_option('-p', '--prng', action = 'store_true', default = False)
parser.add_option('-n', '--nrng', action = 'store_false', default = True)

opts, args = parser.parse_args()

if opts.pcmp:
    pcmp()
    print

if opts.prng:
    prng()
    print

if opts.nrng:
    nrng()

