
import os
import yaml

from pyrange import frange
from pyrange import omg as omg

def test():
    '''
    Compare results by pyrange with the original inspiral_range results
    '''

    bdir = os.path.dirname(__file__)+'/../psd/refs/'
    dict = yaml.load(open(bdir+'compare.yaml'))

    for key in dict.keys():
        for m in dict[key].keys():
            hor = dict[key][m]['horizon']
            ref = dict[key][m]['range']
            zhr = omg.z(hor)
            rng = frange(bdir+key, m=m, zmax=zhr*2)
            print '%8s :  m= %4.1f  range= %6.1f %6.1f (%4.1f %%)' %\
                (key, m, rng, ref, 100*(rng/ref-1))

test()

# It should output something like follows:
'''
  CE.txt :  m=  1.4  range= 4159.1 4200.0 (-1.0 %)
  CE.txt :  m= 10.0  range= 5991.3 6000.0 (-0.1 %)
  CE.txt :  m= 30.0  range= 6097.3 6100.0 (-0.0 %)
  2G.txt :  m=  1.4  range=  191.9  191.7 ( 0.1 %)
  2G.txt :  m= 10.0  range=  810.8  809.3 ( 0.2 %)
  2G.txt :  m= 30.0  range= 1647.7 1644.4 ( 0.2 %)
  O3.txt :  m=  1.4  range=  119.1  118.9 ( 0.1 %)
  O3.txt :  m= 10.0  range=  513.7  512.7 ( 0.2 %)
  O3.txt :  m= 30.0  range= 1107.6 1105.1 ( 0.2 %)
  O2.txt :  m=  1.4  range=   79.9   79.8 ( 0.1 %)
  O2.txt :  m= 10.0  range=  345.0  344.2 ( 0.2 %)
  O2.txt :  m= 30.0  range=  776.5  775.1 ( 0.2 %)
'''
