
import numpy as np
from omega import OMEGA

PC_SI   = 3.085677581491367278913937957796471611e16
MSUN_SI = 1.988546954961461467461011951140572744e30

def LuminosityDistance(omg, z):
    return omg.LumD(z)

def UniformComovingVolumeDensity(z, omg):
    return omg.CVD(z)

class Dummy:
    def __init__(self):
        self.omega = OMEGA

def CreateCosmologicalParametersAndRate():
    return Dummy()

def SetCosmologicalParametersDefaultValue(omg):
    pass

def LoadPSD(fn):
    fh = np.loadtxt(fn)
    f  = fh[:,0]
    h  = fh[:,1]

    if np.min(h) > 1e-30:
        h *= h

    i1 = np.where(f<9)
    i2 = np.where(f<=9000)
    i1 = 0      if len(i1[0]) == 0 else i1[0][-1]
    i2 = len(f) if len(i2[0]) == 0 else i2[0][-1]+1

    f  = f[i1:i2]
    h  = h[i1:i2]
    return f,h
